summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-07-15 08:30:38 +0200
committerJim Meyering <meyering@redhat.com>2008-07-15 08:30:38 +0200
commit773be9eca85da9a9a33d42d29ecfd04c9aec5c3f (patch)
tree532df16b7074678bfdb9ad035b8a4ab13d24d940
parent8461d49df08a241e68d4b0d0b1a2b93bafc1246b (diff)
downloadcoreutils-773be9eca85da9a9a33d42d29ecfd04c9aec5c3f.tar.xz
fix two bugs in ptx
* src/ptx.c (fix_output_parameters): Don't let before_max_width go negative -- that would cause an infloop in define_all_fields. (main): Don't clobber name[0] with lists of two or more input files. * tests/misc/ptx: New file. Test for the above. * tests/Makefile.am (TESTS): Add misc/ptx.
-rw-r--r--src/ptx.c7
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/misc/ptx44
3 files changed, 49 insertions, 3 deletions
diff --git a/src/ptx.c b/src/ptx.c
index 827d22ec8..c04c90c7c 100644
--- a/src/ptx.c
+++ b/src/ptx.c
@@ -1353,6 +1353,8 @@ fix_output_parameters (void)
right side, or one on either side. */
before_max_width -= 2 * truncation_string_length;
+ if (before_max_width < 0)
+ before_max_width = 0;
keyafter_max_width -= 2 * truncation_string_length;
}
else
@@ -2112,11 +2114,10 @@ main (int argc, char **argv)
for (file_index = 0; file_index < number_input_files; file_index++)
{
- input_file_name[file_index] = argv[optind];
if (!*argv[optind] || STREQ (argv[optind], "-"))
- input_file_name[0] = NULL;
+ input_file_name[file_index] = NULL;
else
- input_file_name[0] = argv[optind];
+ input_file_name[file_index] = argv[optind];
optind++;
}
}
diff --git a/tests/Makefile.am b/tests/Makefile.am
index f7275f88c..c2da63086 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -120,6 +120,7 @@ TESTS = \
chgrp/no-x \
chgrp/posix-H \
chgrp/recurse \
+ misc/ptx \
misc/test \
misc/seq \
misc/head \
diff --git a/tests/misc/ptx b/tests/misc/ptx
new file mode 100755
index 000000000..cfc15444c
--- /dev/null
+++ b/tests/misc/ptx
@@ -0,0 +1,44 @@
+#!/usr/bin/perl
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+use strict;
+
+my $prog = 'ptx';
+
+# Turn off localization of executable's output.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+(
+["1tok", '-w10', {IN=>"bar\n"}, {OUT=>" bar\n"}],
+["2tok", '-w10', {IN=>"foo bar\n"}, {OUT=>" / bar\n foo/\n"}],
+
+# with coreutils-6.12 and earlier, this would infloop with -wN, N < 10
+["narrow", '-w2', {IN=>"qux\n"}, {OUT=>" qux\n"}],
+["narrow-g", '-g1 -w2', {IN=>"ta\n"}, {OUT=>" ta\n"}],
+
+# with coreutils-6.12 and earlier, this would act like "ptx F1 F1"
+["2files", '-g1 -w1', {IN=>{F1=>"a"}}, {IN=>{F2=>"b"}}, {OUT=>" a\n b\n"}],
+);
+
+@Tests = triple_test \@Tests;
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $fail = run_tests ($prog, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;